#include "rtc.h"
#include "rtc_drv.h"
#include "cpm_reg.h"
#include "sys.h"
#include "lcd.h"

_calendar_obj calendar;//时钟结构体 

struct DS1302DATA gRtcTime = {18,11,25,9,42,5,7};   
const u8 Clock_Time[7]={19,8,8,2,5,50,4};

u8 RTC_One_Sec_Update=0;

static u8 LT_AsciiToBcd(u8 asciiData)  
{  
	u8 bcdData = 0;  
	bcdData = (((asciiData/10)<<4)|((asciiData%10)));  
	return bcdData; 
}  

u8 LT_BcdToAscii(u8 bcdData)  
{  
	u8 asciiData = 0;  
	asciiData = (((bcdData&0xf0)>>4)*10 + (bcdData&0x0f));  
	return asciiData; 
} 

u8 LT_RtcInit(void)
{
	UINT32 rtc_wclk_div = 0;
	u16 i = 0;
	
	rtc_wclk_div = g_sys_clk/10000000;
	if (rtc_wclk_div >= 1)	rtc_wclk_div--;	
	//Update RTC Counter(function case Dir=0)
	
	NVIC_Init(2, 1, PMU_RTC_IRQn, 2);//开RTC中断

	RTC->RTC_PRKEYR = 0x5aa55aa5;					//输入key
	RTC->RTC_PRC1R &= (~WCLK_DIV_MASK);
	RTC->RTC_PRC1R |= (rtc_wclk_div<<3);//8分频
	RTC->RTC_PRC1R &= ~Dir;							//set dir = 0;
	RTC->RTC_PRC1R |= (1<<9);						// int_type[1:0] 下降沿触发中断
	RTC->RTC_PRC1R &= ~(1<<8);
	//RTC->RTC_PRTCR |= CLK_32KHz_IEN;	// 32k 中断
	//RTC->RTC_PRTCR |= CLK_1KHz_IEN;		// 1k 中断
	RTC->RTC_PRC1R |= Sec_IEN;
	DelayUS(10);

	RTC_Get();
	if(calendar.w_year==0 && calendar.w_month ==0 && calendar.w_date == 0)
	{

			RTC_Set(2021,4,28,13,56,1);
	}
	else		RTC_Set(calendar.w_year,calendar.w_month,calendar.w_date,calendar.hour,calendar.min,calendar.sec);

	//	if(RTC->RTC_PRTCR&CLK_32KHz_IEN)
	//printf("RTC->RTC_PRC1R ==%x  \r\n",RTC->RTC_PRC1R);
	return(0);
}

//RTC时钟中断
void PMU_RTC_IRQHandler(void)
{
	UINT32 prc1r;
	//printf("calendar.sec.second  ==%d  \r\n",calendar.sec);

	prc1r = RTC->RTC_PRC1R;

	if(((prc1r&Sec_intf) == Sec_intf) && ((prc1r&Sec_IEN) == Sec_IEN))//second interrupt
	{
		RTC->RTC_PRC1R |= Sec_intf;
		
		RTC_Get();
//		printf("Y:%d M:%d D:%d\r\nh:%d m:%d s:%d\r\nw:%d\r\n\r\n",calendar.w_year,calendar.w_month,calendar.w_date,calendar.hour,calendar.min,calendar.sec,calendar.week);
		
	}
		
}


//判断是否是闰年函数
//月份   1  2  3  4  5  6  7  8  9  10 11 12
//闰年   31 29 31 30 31 30 31 31 30 31 30 31
//非闰年 31 28 31 30 31 30 31 31 30 31 30 31
//输入:年份
//输出:该年份是不是闰年.1,是.0,不是
u8 Is_Leap_Year(u16 year)
{			  
	if(year%4==0) //必须能被4整除
	{ 
		if(year%100==0) 
		{ 
			if(year%400==0)return 1;//如果以00结尾,还要能被400整除 	   
			else return 0;   
		}else return 1;   
	}else return 0;	
}	 			   
//设置时钟
//把输入的时钟转换为秒钟
//以1970年1月1日为基准
//1970~2099年为合法年份
//返回值:0,成功;其他:错误代码.
//月份数据表											 
u8 const table_week[12]={0,3,3,6,1,4,6,2,5,0,3,5}; //月修正数据表	  
//平年的月份日期表
const u8 mon_table[12]={31,28,31,30,31,30,31,31,30,31,30,31};
u8 RTC_Set(u16 syear,u8 smon,u8 sday,u8 hour,u8 min,u8 sec)
{
	u16 t;
	tm timer;
	UINT16 days=0;
	
	if(syear<2010||syear>2099)return 1;	   
	for(t=2010;t<syear;t++)	//把所有年份的秒钟相加
	{
		if(Is_Leap_Year(t))days+=366;//闰年的秒钟数
		else days+=365;			  //平年的秒钟数
	}
	smon-=1;
	for(t=0;t<smon;t++)	   //把前面月份的秒钟数相加
	{
		days+=(u32)mon_table[t];//月份秒钟数相加
		if(Is_Leap_Year(syear)&&t==1)	days++;//闰年2月份增加一天的秒钟数	   
	}
	days+=(sday-1);//把前面日期的秒钟数相加 

	timer.day = days;
	timer.hour = hour;
	timer.minute = min;
	timer.second = sec;
	
	RTC_SetTime(timer);
	
	return 0;	    
}

//得到当前的时间
//返回值:0,成功;其他:错误代码.
u8 RTC_Get(void)
{
	static u16 daycnt=0;

	u32 temp=0;
	u16 temp1=0;	  
	UINT16 days=0;
	tm timer;
	
	RTC_GetTime(&timer);
	days = timer.day;
	 
 	temp=days;   //得到天数
	if(daycnt!=temp)//超过一天了
	{	  
		daycnt=temp;
		temp1=2010;	//从2010年开始
		while(temp>=365)
		{				 
			if(Is_Leap_Year(temp1))//是闰年
			{
				if(temp>=366)temp-=366;//闰年的秒钟数
				else {temp1++;break;}  
			}
			else temp-=365;	  //平年 
			temp1++;  
		}   
		calendar.w_year=temp1;//得到年份
		temp1=0;
		while(temp>=28)//超过了一个月
		{
			if(Is_Leap_Year(calendar.w_year)&&temp1==1)//当年是不是闰年/2月份
			{
				if(temp>=29)temp-=29;//闰年的秒钟数
				else break; 
			}
			else 
			{
				if(temp>=mon_table[temp1])temp-=mon_table[temp1];//平年
				else break;
			}
			temp1++;  
		}
		calendar.w_month=temp1+1;	//得到月份
		calendar.w_date=temp+1;  	//得到日期 
	}
	calendar.hour = timer.hour;
	calendar.min = timer.minute;
	calendar.sec = timer.second; 
	calendar.week=RTC_Get_Week(calendar.w_year,calendar.w_month,calendar.w_date);//获取星期   
	return 0;
}	

//获得现在是星期几
//功能描述:输入公历日期得到星期(只允许1901-2099年)
//输入参数：公历年月日 
//返回值：星期号																						 
u8 RTC_Get_Week(u16 year,u8 month,u8 day)
{	
	u16 temp2;
	u8 yearH,yearL;
	
	yearH=year/100;	yearL=year%100; 
	// 如果为21世纪,年份数加100  
	if (yearH>19)yearL+=100;
	// 所过闰年数只算1900年之后的  
	temp2=yearL+yearL/4;
	temp2=temp2%7; 
	temp2=temp2+day+table_week[month-1];
	if (yearL%4==0&&month<3)temp2--;
	return(temp2%7);
}			 






